﻿Imports System.Net
Imports System.Windows
Imports System.Windows.Controls
Imports System.Windows.Documents
Imports System.Windows.Input
Imports System.Windows.Media
Imports System.Windows.Media.Animation
Imports System.Windows.Shapes
Imports Telerik.Windows.Controls
Imports System.Threading
Imports System.Windows.Threading

Namespace SilverlightApplication1
	Partial Public Class MainPage
		Inherits UserControl
		Private newOffset As FrameworkElement
		Public Sub New()
			InitializeComponent()
			AddHandler Loaded, AddressOf MainPage_Loaded
		End Sub

		Private Sub MainPage_Loaded(ByVal sender As Object, ByVal e As RoutedEventArgs)
			AddExpander()

		End Sub
		Private Sub UpdateScroller()
			' MessageBox.Show(expStack.ActualHeight)
			'expSV.ScrollIntoView(newOffset);
		End Sub

		Private Sub expanderPanel_Collapsed(ByVal sender As Object, ByVal e As System.Windows.RoutedEventArgs)
			AddHandler expSV.LayoutUpdated, AddressOf expSV_LayoutUpdated
		End Sub

		Private Sub expanderPanel_Expanded(ByVal sender As Object, ByVal e As System.Windows.RoutedEventArgs)
			Dim expander As RadExpander = TryCast(sender, RadExpander)
			Dim expanderTransform As GeneralTransform = expander.TransformToVisual(expSV)
			Dim rectangle As Rect = expanderTransform.TransformBounds(New Rect(New Point(expander.Margin.Left, expander.Margin.Top), expander.RenderSize))
			Dim newOffset As Double = expSV.VerticalOffset + ((rectangle.Bottom + 100) - expSV.ViewportHeight)

			Dim timer As New DispatcherTimer() With {.Interval = TimeSpan.FromMilliseconds(1000)}
			AddHandler timer.Tick, Sub(o, args)
				Dispatcher.BeginInvoke(Sub() expSV.ScrollToVerticalOffset(expSV.VerticalOffset + newOffset))
				timer.Stop()
			End Sub
			timer.Start()
		End Sub

		Private Sub AddExpander()
			For i As Integer = 0 To 10
				Dim expanderPanel As New RadExpander()
				AddHandler expanderPanel.Expanded, AddressOf expanderPanel_Expanded
				AddHandler expanderPanel.Collapsed, AddressOf expanderPanel_Collapsed
				Telerik.Windows.Controls.Animation.AnimationManager.SetIsAnimationEnabled(expanderPanel, True)
				Telerik.Windows.Controls.Animation.AnimationManager.AnimationSpeedRatio = 0.35
				Dim grdHeader As New Grid()
				Dim column0 As New ColumnDefinition()
				column0.Width = New GridLength(25)
				grdHeader.ColumnDefinitions.Add(column0)
				Dim column1 As New ColumnDefinition()
				column1.Width = New GridLength(250)
				grdHeader.ColumnDefinitions.Add(column1)
				Dim column2 As New ColumnDefinition()
				column2.Width = New GridLength(5)
				grdHeader.ColumnDefinitions.Add(column2)
				Dim column3 As New ColumnDefinition()
				column3.Width = New GridLength(330)
				grdHeader.ColumnDefinitions.Add(column3)
				Dim column4 As New ColumnDefinition()
				column4.Width = New GridLength(55)
				grdHeader.ColumnDefinitions.Add(column4)
				Dim column5 As New ColumnDefinition()
				column5.Width = New GridLength(75)
				grdHeader.ColumnDefinitions.Add(column5)
				Dim txtComName As New TextBlock()
				txtComName.TextAlignment = TextAlignment.Center
				txtComName.FontWeight = FontWeights.Bold
				txtComName.Foreground = New SolidColorBrush(Colors.Black)
				txtComName.TextWrapping = TextWrapping.Wrap
				txtComName.Text = "Company" & Convert.ToString(i)
				txtComName.SetValue(Grid.ColumnProperty, 1)
				grdHeader.Children.Add(txtComName)
				Dim txtPart2 As New TextBlock()
				txtPart2.Foreground = New SolidColorBrush(Colors.Black)
				txtPart2.Text = "|"
				txtPart2.SetValue(Grid.ColumnProperty, 2)
				grdHeader.Children.Add(txtPart2)
				Dim txtContName As New TextBlock()
				txtContName.TextAlignment = TextAlignment.Center
				txtContName.FontWeight = FontWeights.Bold
				txtContName.Foreground = New SolidColorBrush(Colors.Black)
				txtContName.TextWrapping = TextWrapping.Wrap
				txtContName.Text = "ContactName" & Convert.ToString(i)
				txtContName.SetValue(Grid.ColumnProperty, 3)
				grdHeader.Children.Add(txtContName)
				Dim txtPart4 As New TextBlock()
				txtPart4.Foreground = New SolidColorBrush(Colors.Black)
				txtPart4.Text = "|"
				txtPart4.SetValue(Grid.ColumnProperty, 4)
				grdHeader.Children.Add(txtPart4)
				Dim btnSelect As New Button()
				btnSelect.Width = 55
				btnSelect.Cursor = Cursors.Hand
				btnSelect.SetValue(Grid.ColumnProperty, 5)
				grdHeader.Children.Add(btnSelect)
				expanderPanel.Header = grdHeader
				'Panel Content
				Dim grdContent As New Grid()
				Dim columnA As New ColumnDefinition()
				columnA.Width = New GridLength(100)
				grdContent.ColumnDefinitions.Add(columnA)
				'column added
				Dim columnAC As New ColumnDefinition()
				columnAC.Width = New GridLength(150)
				grdContent.ColumnDefinitions.Add(columnAC)
				Dim columnPart1 As New ColumnDefinition()
				columnPart1.Width = New GridLength(5)
				grdContent.ColumnDefinitions.Add(columnPart1)
				Dim columnB As New ColumnDefinition()
				columnB.Width = New GridLength(150)
				grdContent.ColumnDefinitions.Add(columnB)
				'column added
				Dim columnBC As New ColumnDefinition()
				columnAC.Width = New GridLength(200)
				grdContent.ColumnDefinitions.Add(columnBC)
				Dim columnPart2 As New ColumnDefinition()
				columnPart2.Width = New GridLength(5)
				grdContent.ColumnDefinitions.Add(columnPart2)
				'column added
				Dim columnCA As New ColumnDefinition()
				columnCA.Width = New GridLength(100)
				grdContent.ColumnDefinitions.Add(columnCA)
				Dim columnC As New ColumnDefinition()
				columnC.Width = New GridLength(140)
				grdContent.ColumnDefinitions.Add(columnC)
				Dim rowA As New RowDefinition()
				rowA.Height = New GridLength(5)
				grdContent.RowDefinitions.Add(rowA)
				Dim rowB As New RowDefinition()
				grdContent.RowDefinitions.Add(rowB)
				Dim rowC As New RowDefinition()
				grdContent.RowDefinitions.Add(rowC)
				Dim rowD As New RowDefinition()
				rowD.Height = New GridLength(25)
				grdContent.RowDefinitions.Add(rowD)
				Dim rowE As New RowDefinition()
				rowE.Height = New GridLength(10)
				grdContent.RowDefinitions.Add(rowE)
				Dim tbHeading1 As New TextBlock()
				tbHeading1.Text = "Company Name : "
				tbHeading1.TextAlignment = TextAlignment.Right
				tbHeading1.SetValue(Grid.ColumnProperty, 0)
				tbHeading1.SetValue(Grid.RowProperty, 1)
				grdContent.Children.Add(tbHeading1)
				Dim tbComName As New TextBlock()
				tbComName.Text = "CompanyName" & Convert.ToString(i)
				tbComName.TextAlignment = TextAlignment.Left
				tbComName.TextWrapping = TextWrapping.Wrap
				tbComName.SetValue(Grid.ColumnProperty, 1)
				tbComName.SetValue(Grid.RowProperty, 1)
				grdContent.Children.Add(tbComName)
				Dim tbContName As New TextBlock()
				Dim tbHeading As New TextBlock()
				tbHeading.Text = "Contact Name : "
				tbHeading.TextAlignment = TextAlignment.Right
				tbHeading.SetValue(Grid.ColumnProperty, 0)
				tbHeading.SetValue(Grid.RowProperty, 2)
				grdContent.Children.Add(tbHeading)
				tbContName.Text = "ContactName" & Convert.ToString(i)
				tbContName.TextAlignment = TextAlignment.Left
				tbContName.TextWrapping = TextWrapping.Wrap
				tbContName.SetValue(Grid.ColumnProperty, 1)
				tbContName.SetValue(Grid.RowProperty, 2)
				grdContent.Children.Add(tbContName)
				Dim txtPart5 As New TextBlock()
				txtPart5.Text = "|"
				txtPart5.SetValue(Grid.ColumnProperty, 2)
				txtPart5.SetValue(Grid.RowProperty, 1)
				grdContent.Children.Add(txtPart5)
				Dim txtPart6 As New TextBlock()
				txtPart6.Text = "|"
				txtPart6.SetValue(Grid.ColumnProperty, 2)
				txtPart6.SetValue(Grid.RowProperty, 2)
				grdContent.Children.Add(txtPart6)
				Dim tbHeading3 As New TextBlock()
				tbHeading3.Text = "Email : "
				tbHeading3.TextAlignment = TextAlignment.Right
				tbHeading3.SetValue(Grid.ColumnProperty, 3)
				tbHeading3.SetValue(Grid.RowProperty, 1)
				grdContent.Children.Add(tbHeading3)
				Dim tbHeading4 As New TextBlock()
				tbHeading4.Text = "Telephone Number : "
				tbHeading4.TextAlignment = TextAlignment.Right
				tbHeading4.SetValue(Grid.ColumnProperty, 3)
				tbHeading4.SetValue(Grid.RowProperty, 2)
				grdContent.Children.Add(tbHeading4)
				Dim tbEmail As New TextBlock()
				tbEmail.TextAlignment = TextAlignment.Left
				tbEmail.VerticalAlignment = VerticalAlignment.Stretch
				tbEmail.TextWrapping = TextWrapping.Wrap
				tbEmail.Text = "Email" & Convert.ToString(i)
				'End If
				tbEmail.SetValue(Grid.ColumnProperty, 4)
				tbEmail.SetValue(Grid.RowProperty, 1)
				grdContent.Children.Add(tbEmail)
				Dim txtPart7 As New TextBlock()
				txtPart7.Text = "|"
				txtPart7.SetValue(Grid.ColumnProperty, 5)
				txtPart7.SetValue(Grid.RowProperty, 1)
				grdContent.Children.Add(txtPart7)
				Dim tbPhone As New TextBlock()
				tbPhone.Text = "Telephone" & Convert.ToString(i)
				tbPhone.TextAlignment = TextAlignment.Left
				tbPhone.SetValue(Grid.ColumnProperty, 4)
				tbPhone.SetValue(Grid.RowProperty, 2)
				grdContent.Children.Add(tbPhone)
				Dim txtPart8 As New TextBlock()
				txtPart8.Text = "|"
				txtPart8.SetValue(Grid.ColumnProperty, 5)
				txtPart8.SetValue(Grid.RowProperty, 2)
				grdContent.Children.Add(txtPart8)
				Dim tbHeading5 As New TextBlock()
				tbHeading5.Text = "End User Type : "
				tbHeading5.TextAlignment = TextAlignment.Right
				tbHeading5.SetValue(Grid.ColumnProperty, 6)
				tbHeading5.SetValue(Grid.RowProperty, 1)
				grdContent.Children.Add(tbHeading5)
				Dim tbHeading6 As New TextBlock()
				tbHeading6.Text = "City : "
				tbHeading6.TextAlignment = TextAlignment.Right
				tbHeading6.SetValue(Grid.ColumnProperty, 6)
				tbHeading6.SetValue(Grid.RowProperty, 2)
				grdContent.Children.Add(tbHeading6)
				Dim tbEUType As New TextBlock()
				tbEUType.Text = "EndUserType"
				tbEUType.TextAlignment = TextAlignment.Left
				tbEUType.TextWrapping = TextWrapping.Wrap
				tbEUType.SetValue(Grid.ColumnProperty, 7)
				tbEUType.SetValue(Grid.RowProperty, 1)
				grdContent.Children.Add(tbEUType)
				Dim tbCity As New TextBlock()
				tbCity.Text = "City"
				tbCity.TextAlignment = TextAlignment.Left
				tbCity.TextWrapping = TextWrapping.Wrap
				tbCity.SetValue(Grid.ColumnProperty, 7)
				tbCity.SetValue(Grid.RowProperty, 2)
				grdContent.Children.Add(tbCity)
				Dim btnViewDetails As New Button()
				btnViewDetails.Width = 80
				btnViewDetails.HorizontalAlignment = HorizontalAlignment.Left
				btnViewDetails.Cursor = Cursors.Hand
				btnViewDetails.SetValue(Grid.ColumnProperty, 4)
				btnViewDetails.SetValue(Grid.RowProperty, 3)
				grdContent.Children.Add(btnViewDetails)
				expanderPanel.Content = grdContent
				expanderPanel.ExpandDirection = Telerik.Windows.Controls.ExpandDirection.Down
				expStack.Children.Add(expanderPanel)
				Dispatcher.BeginInvoke(Sub()
					Dim firstChild As FrameworkElement = TryCast(VisualTreeHelper.GetChild(expanderPanel, 0), FrameworkElement)
					If (firstChild IsNot Nothing) Then
						Dim button As Control = TryCast(firstChild.FindName("HeaderButton"), Control)
						button.Tag = i
					End If
				End Sub)
			Next i
		End Sub

		Private Sub expSV_LayoutUpdated(ByVal sender As Object, ByVal e As EventArgs)
			Dim focusedElement As FrameworkElement = TryCast(FocusManager.GetFocusedElement(), FrameworkElement)
			Dim focusedVisualTransform As GeneralTransform = focusedElement.TransformToVisual(expSV)
			Dim rectangle As Rect = focusedVisualTransform.TransformBounds(New Rect(New Point(focusedElement.Margin.Left, focusedElement.Margin.Top), focusedElement.RenderSize))
			Dim count As Integer = (CType(CObj(expSV.Content), System.Windows.Controls.StackPanel)).Children.Count
			Dim foundElement As Boolean = False
			Dim i As Integer = 1
			For Each element As RadExpander In (CType(CObj(expSV.Content), System.Windows.Controls.StackPanel)).Children
				Dim firstChild As FrameworkElement = TryCast(VisualTreeHelper.GetChild(element, 0), FrameworkElement)
				If (firstChild IsNot Nothing) Then
					Dim button As Control = TryCast(firstChild.FindName("HeaderButton"), System.Windows.Controls.Control)
					If foundElement Then
						newOffset = firstChild
						Exit For ' TODO: might not be correct. Was : Exit For
					End If
					If button.Tag = focusedElement.Tag Then
						foundElement = True
						If i = count Then
							newOffset = firstChild
							Exit For ' TODO: might not be correct. Was : Exit For
						End If
					End If
				End If
				i = i + 1
			Next element
			Dispatcher.BeginInvoke(AddressOf UpdateScroller)
			RemoveHandler expSV.LayoutUpdated, AddressOf expSV_LayoutUpdated
		End Sub

		Private Sub Button_Click(ByVal sender As Object, ByVal e As RoutedEventArgs)

		End Sub
	End Class
End Namespace
